﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ProjectAirFighter.Drawning;
using ProjectAirFighter.Entities;

namespace ProjectAirFighter
{
    public partial class FormAirFighter : Form


    {
        private DrawningWarPlane? _drawningWarPlane;

     
        /// <summary>
        /// Стратегия перемещения
        /// </summary>
        //private AbstractStrategy? _strategy;
        /// <summary>
        /// Конструктор формы
        /// </summary>
        public FormAirFighter()
        {
            InitializeComponent();
            //_strategy = null;
        }
        /// <summary>
        /// Метод прорисовки
        /// </summary>
        private void Draw()
        {
            if (_drawningWarPlane == null) return;

            Bitmap bmp = new(pictureBoxAirFighter.Width, pictureBoxAirFighter.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawningWarPlane.DrawTransport(gr);
            pictureBoxAirFighter.Image = bmp;
        }
        private void CreateObject(string type)
        {
            Random random = new();
            switch (type)
            {
                case nameof(DrawningWarPlane):
                    _drawningWarPlane = new DrawningWarPlane(random.Next(100, 300),
                    random.Next(1000, 3000),
                    Color.FromArgb(random.Next(0, 256),
                    random.Next(0, 256), random.Next(0, 256)));
                    break;
                case nameof(DrawningAirFighter):
                    _drawningWarPlane = new DrawningAirFighter(random.Next(100,
                    300), random.Next(1000, 3000),
                    Color.FromArgb(random.Next(0, 256),
                    random.Next(0, 256), random.Next(0, 256)),
                    Color.FromArgb(random.Next(0, 256),
                    random.Next(0, 256), random.Next(0, 256)),
                    Convert.ToBoolean(random.Next(0, 2)),
                    Convert.ToBoolean(random.Next(0, 2)));
                    break;
                default:
                    return;
            }
            _drawningWarPlane.SetPictureSize(pictureBoxAirFighter.Width,
            pictureBoxAirFighter.Height);
            _drawningWarPlane.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            CreateObject(nameof(DrawningAirFighter));
        }
        private void buttonCreateWarPlane_Click(object sender, EventArgs e)
        {
            CreateObject(nameof(DrawningWarPlane));
        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_drawningWarPlane == null)
            {
                return;
            }

            string name = ((Button)sender)?.Name ?? string.Empty;
            bool result = false;
            switch (name)
            {
                case "buttonUp":
                    result = _drawningWarPlane.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    result = _drawningWarPlane.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    result = _drawningWarPlane.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    result = _drawningWarPlane.MoveTransport(DirectionType.Right);
                    break;
            }
            if (result)
            {
                Draw();
            }


        }
        private void FormAirFighter_SizeChanged(object sender, EventArgs e)
        {
            if (_drawningWarPlane == null) return;


            _drawningWarPlane.SetPictureSize(pictureBoxAirFighter.Width, pictureBoxAirFighter.Height);


            if (_drawningWarPlane.SetPictureSize(pictureBoxAirFighter.Width, pictureBoxAirFighter.Height))
            {
                Draw();
            }

        }

        
    }
}
